//+------------------------------------------------------------------+
//|                                           FX Sniper's T3 CCI.mq4 |
//|                                                        FX Sniper |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "FX Sniper:  T3-CCI :-)"
#property link      "http://dunno.com  :-)/"

#property indicator_separate_window
#property indicator_buffers 11
#property indicator_color1   Blue
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  PaleGreen
#property  indicator_color5  HotPink
#property  indicator_color6  LimeGreen
#property  indicator_color7  Pink
#property  indicator_color8  LimeGreen
#property  indicator_color9  Pink
#property  indicator_color10  Lime
#property  indicator_color11  Red

#property  indicator_width8  1
#property  indicator_width9  1
#property  indicator_width10  1
#property  indicator_width11  1

//----
extern int CCI_Period = 14;
extern int T3_Period = 5;
extern double b = 0.618;

extern double lower_level = 100;
extern double higher_level = 200;
extern double exit_level = 0;
extern double exit_extrem_level = 100;
//----
double e1, e2, e3, e4, e5, e6;
double c1, c2, c3, c4;
double n, w1, w2, b2, b3;
double cci[];
double cciHup[];
double cciHdn[];
double cross_up_lower_level[];
double cross_down_lower_level[];
double cross_up_higher_level[];
double cross_down_higher_level[];
double exit_price_up[];
double exit_price_down[];
double exit_up_cci_lower[];
double exit_down_cci_higher[];




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
    SetIndexBuffer(0, cci);
    SetIndexBuffer(1, cciHup);
    SetIndexBuffer(2, cciHdn);
//----
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_HISTOGRAM);
    SetIndexStyle(2, DRAW_HISTOGRAM); 
//----        
    IndicatorShortName("FXST3CCI(" + CCI_Period + ", " + T3_Period + ")");
    SetIndexLabel(0, "FXST3CCI");     
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL); 
     
     
   
   SetIndexBuffer(3,cross_up_lower_level);
   SetIndexStyle(3,DRAW_ARROW);  
   SetIndexArrow(3, 233);  
   SetIndexLabel(3,"bullish");
   
   SetIndexBuffer(4,cross_down_lower_level);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4, 234);  
   SetIndexLabel(4,"bearish");
  
   SetIndexBuffer(5,cross_up_higher_level);
   SetIndexStyle(5,DRAW_ARROW);  
   SetIndexArrow(5, 233);  
   
   SetIndexBuffer(6,cross_down_higher_level);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6, 234);  
     
   SetIndexBuffer(7,exit_price_up);
   SetIndexStyle(7,DRAW_ARROW);  
   SetIndexArrow(7, 108);  
   
   SetIndexBuffer(8,exit_price_down);
   SetIndexStyle(8,DRAW_ARROW);
   SetIndexArrow(8, 108);  
    
   SetIndexBuffer(9,exit_up_cci_lower );
   SetIndexStyle(9,DRAW_ARROW);  
   SetIndexArrow(9, 170);  
   
   SetIndexBuffer(10,exit_down_cci_higher);
   SetIndexStyle(10,DRAW_ARROW);
   SetIndexArrow(10, 170);      
    
    SetLevelValue(0, lower_level);
    SetLevelValue(1, -lower_level);
    SetLevelValue(2, higher_level);
    SetLevelValue(3, -higher_level);
    SetLevelStyle(0,0,Yellow);     
     
     
//---- variable reset
    b2 = b*b;
    b3 = b2*b;
    c1 = -b3;
    c2 = (3*(b2 + b3));
    c3 = -3*(2*b2 + b + b3);
    c4 = (1 + 3*b + b3 + 3*b2);
    n = T3_Period;
//----
    if(n < 1) 
        n = 1;
    n = 1 + 0.5*(n - 1);
    w1 = 2 / (n + 1);
    w2 = 1 - w1;    
    

    
    
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0)   counted_bars--;
   limit = Bars - counted_bars;  
//---- indicator calculation
   for(int i = limit; i >= 0; i--)
     {   
       cci[i] = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, i);
       e1 = w1*cci[i] + w2*e1;
       e2 = w1*e1 + w2*e2;
       e3 = w1*e2 + w2*e3;
       e4 = w1*e3 + w2*e4;
       e5 = w1*e4 + w2*e5;
       e6 = w1*e5 + w2*e6;    
       cci[i] = c1*e6 + c2*e5 + c3*e4 + c4*e3;  
       //----
       if(cci[i] >= 0)           cciHup[i] = cci[i];
       else                      cciHup[i] = 0;          //----
       if(cci[i] < 0 )           cciHdn[i] = cci[i];
       else                      cciHdn[i] = 0; 
       
       
      if( cci[i+1] < lower_level && cci[i] > lower_level ) cross_up_lower_level[i] = lower_level;
      if( cci[i+1] < higher_level && cci[i] > higher_level ) cross_up_higher_level[i] = higher_level;
   
      if( cci[i+1] > -lower_level && cci[i] < -lower_level ) cross_down_higher_level[i] = -lower_level;
      if( cci[i+1] > -higher_level && cci[i] < -higher_level ) cross_down_higher_level[i] = -higher_level;
       
      if( cci[i+1] > exit_level && cci[i] < exit_level ) exit_price_down[i] = exit_level;
      if( cci[i+1] < -exit_level && cci[i] > -exit_level  ) exit_price_up[i] = -exit_level;
       
       
        if( cci[i] > exit_extrem_level &&  cci[i+2] < cci[i+1] && cci[i+1] > cci[i] ) exit_down_cci_higher[i] = cci[i]+40;
        if( cci[i] < -exit_extrem_level &&  cci[i+2] > cci[i+1] && cci[i+1] < cci[i] ) exit_up_cci_lower[i] = cci[i]-40;
     }   
//----
   return(0);
  }
//+------------------------------------------------------------------+