//+------------------------------------------------------------------+
//|                                                   Percentage.mq4 |
//|  Copyright  2009, Arif Endro Nugroho <arif_endro@vectra.web.id> |
//|                                         http://www.vectra.web.id |
//|  Last updated: 2009.06.29 17:30 GMT+7                            |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Arif E. Nugroho <arif_endro@vectra.web.id>"
#property link      "http://www.vectra.web.id"

#property indicator_chart_window
//---- input parameters
extern int       corner=2;
extern int       xdis=5;
extern int       ydis=20;
extern string    Font="Lucida Console";
extern int       FontSize=8;
extern color     FontPlus=Blue;
extern color     FontMinus=Red;
extern int       timezone=7;
extern bool      back=0;
extern bool      ShowHighLow=false;
extern bool      ShowHighLowPercentage=false;
extern bool      ShowOpenClose=true;
extern bool      ShowHorizontalLine=false;

extern bool      ShowSignal=false;
extern bool      ShowSignalValue=false;

extern bool      DailyPercentageLevel=false;
extern color     DayZeroColor=Gold;
extern color     DayUpColor=Blue;
extern color     DayDownColor=Red;

extern bool      WeeklyPercentageLevel=false;
extern color     WeekZeroColor=Silver;
extern color     WeekUpColor=RoyalBlue;
extern color     WeekDownColor=OrangeRed;

extern bool      MonthlyPercentageLevel=false;
extern color     MonthZeroColor=Lavender;
extern color     MonthUpColor=SkyBlue;
extern color     MonthDownColor=Orange;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("DailyStat");
   ObjectDelete("WeeklyStat");
   ObjectDelete("MonthlyStat");
if(ShowSignal) {
   ObjectDelete("MACDInfo");
   ObjectDelete("StochInfo");
   ObjectDelete("RSIInfo");
   ObjectDelete("IchimokuInfo");
   }
if(DailyPercentageLevel){   
   ObjectDelete("PLUp25");
   ObjectDelete("PLDown25");
   ObjectDelete("PLUp50");
   ObjectDelete("PLDown50");
   ObjectDelete("PLUp100");
   ObjectDelete("PLDown100");
   ObjectDelete("PLUp150");
   ObjectDelete("PLDown150");
   ObjectDelete("PLUp200");
   ObjectDelete("PLDown200");
   ObjectDelete("+0.25");
   ObjectDelete("-0.25");
   ObjectDelete("+0.5");
   ObjectDelete("-0.5");
   ObjectDelete("+1.0");
   ObjectDelete("-1.0");
   ObjectDelete("+1.5");
   ObjectDelete("-1.5");
   ObjectDelete("+2.0");
   ObjectDelete("-2.0");   
   ObjectDelete("PL0.0");
   ObjectDelete("0.0");
   }

if(WeeklyPercentageLevel){
   ObjectDelete("PL0.0W");
   ObjectDelete("PLUp100W");
   ObjectDelete("PLDown100W");
   ObjectDelete("PLUp200W");
   ObjectDelete("PLDown200W");
   ObjectDelete("PLUp300W");
   ObjectDelete("PLDown300W");
   ObjectDelete("PLUp400W");
   ObjectDelete("PLDown400W");
   ObjectDelete("0.");
   ObjectDelete("+1.");
   ObjectDelete("-1.");
   ObjectDelete("+2.");
   ObjectDelete("-2.");
   ObjectDelete("+3.");
   ObjectDelete("-3.");
   ObjectDelete("+4.");
   ObjectDelete("-4.");
   }

if(MonthlyPercentageLevel){
   ObjectDelete("PL0.0M");
   ObjectDelete("PLUp200M");
   ObjectDelete("PLDown200M");
   ObjectDelete("PLUp400M");
   ObjectDelete("PLDown400M");
   ObjectDelete("PLUp600M");
   ObjectDelete("PLDown600M");
   ObjectDelete("PLUp800M");
   ObjectDelete("PLDown800M");
   ObjectDelete("0");
   ObjectDelete("+2");
   ObjectDelete("-2");
   ObjectDelete("+4");
   ObjectDelete("-4");
   ObjectDelete("+6");
   ObjectDelete("-6");
   ObjectDelete("+8");
   ObjectDelete("-8");
   }

if(ShowHorizontalLine) {
   ObjectDelete("0.0HLD");
   ObjectDelete("+0.25HLD");
   ObjectDelete("-0.25HLD");
   ObjectDelete("+0.5HLD");
   ObjectDelete("-0.5HLD");
   ObjectDelete("+1.0HLD");
   ObjectDelete("-1.0HLD");
   ObjectDelete("+1.5HLD");
   ObjectDelete("-1.5HLD");
   ObjectDelete("+2.0HLD");
   ObjectDelete("-2.0HLD");
   ObjectDelete("0HLW");
   ObjectDelete("+1HLW");
   ObjectDelete("-1HLW");
   ObjectDelete("+2HLW");
   ObjectDelete("-2HLW");
   ObjectDelete("+3HLW");
   ObjectDelete("-3HLW");
   ObjectDelete("+4HLW");
   ObjectDelete("-4HLW");
   ObjectDelete("0HLM");
   ObjectDelete("+2HLM");
   ObjectDelete("-2HLM");
   ObjectDelete("+4HLM");
   ObjectDelete("-4HLM");
   ObjectDelete("+6HLM");
   ObjectDelete("-6HLM");
   ObjectDelete("+8HLM");
   ObjectDelete("-8HLM");
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();

   int    DayShift    = iBarShift(NULL, PERIOD_D1, iTime(NULL, PERIOD_D1, 0)) + 0;
   double DayOpPrice  = iOpen(NULL, PERIOD_D1, DayShift); 
   double DayClPrice  = iClose(NULL, PERIOD_D1, DayShift);
   double DayHiPrice  = iHigh(NULL, PERIOD_D1, DayShift); 
   double DayLoPrice  = iLow(NULL, PERIOD_D1, DayShift);

   int    WeekShift   = iBarShift(NULL, PERIOD_W1, iTime(NULL, PERIOD_W1, 0)) + 0;
   double WeekOpPrice = iOpen(NULL, PERIOD_W1, WeekShift);
   double WeekClPrice = iClose(NULL, PERIOD_W1, WeekShift);
   double WeekHiPrice = iHigh(NULL, PERIOD_W1, WeekShift);
   double WeekLoPrice = iLow(NULL, PERIOD_W1, WeekShift);

   int    MonthShift= iBarShift(NULL, PERIOD_MN1, iTime(NULL, PERIOD_MN1, 0)) + 0;
   double MonthOpPrice= iOpen(NULL, PERIOD_MN1, MonthShift);
   double MonthClPrice= iClose(NULL, PERIOD_MN1, MonthShift);
   double MonthHiPrice= iHigh(NULL, PERIOD_MN1, MonthShift);
   double MonthLoPrice= iLow(NULL, PERIOD_MN1, MonthShift);

   color  FontColorDayPercentGain = Silver;
   color  FontColorWeekPercentGain = Silver;
   color  FontColorMonthPercentGain = Silver;
   
   color  MACDColor  = Gold;
   string MACDInfo   = "MACD.....:";

   color  StochColor = Gold;
   string StochInfo  = "Stoch....:";
   
   color  RSIColor   = Gold;
   string RSIInfo    = "RSI......:";

   color  IchimokuColor   = Gold;
   string IchimokuInfo    = "Ichimoku.:";

   string DailyInfo  = "Daily....:";
   string WeeklyInfo = "Weekly...:";
   string MonthlyInfo= "Monthly..:";
  
   if (ShowHighLow) {
     DailyInfo   = DailyInfo   + " " + DoubleToStr(DayHiPrice, Digits)   + "/" + DoubleToStr(DayLoPrice, Digits);
     WeeklyInfo  = WeeklyInfo  + " " + DoubleToStr(WeekHiPrice, Digits)  + "/" + DoubleToStr(WeekLoPrice, Digits);
     MonthlyInfo = MonthlyInfo + " " + DoubleToStr(MonthHiPrice, Digits) + "/" + DoubleToStr(MonthLoPrice, Digits);
     if(ShowHighLowPercentage) {
        DailyInfo   = DailyInfo    + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(DayHiPrice-DayLoPrice), 0)     + "|" + DoubleToStr(100*(MathAbs(DayHiPrice-DayLoPrice)/DayLoPrice),2)       + "%]";
        WeeklyInfo  = WeeklyInfo   + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(WeekHiPrice-WeekLoPrice), 0)   + "|" + DoubleToStr(100*(MathAbs(WeekHiPrice-WeekLoPrice)/WeekLoPrice),2)    + "%]"; 
        MonthlyInfo = MonthlyInfo  + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(MonthHiPrice-MonthLoPrice), 0) + "|" + DoubleToStr(100*(MathAbs(MonthHiPrice-MonthLoPrice)/MonthLoPrice),2) + "%]";
     }
   }
   
   if (ShowOpenClose) {
   DailyInfo   = DailyInfo   + " " + DoubleToStr(DayOpPrice, Digits)   + "/" + DoubleToStr(DayClPrice, Digits);
   WeeklyInfo  = WeeklyInfo  + " " + DoubleToStr(WeekOpPrice, Digits)  + "/" + DoubleToStr(WeekClPrice, Digits);
   MonthlyInfo = MonthlyInfo + " " + DoubleToStr(MonthOpPrice, Digits) + "/" + DoubleToStr(MonthClPrice, Digits);
   }
   
   DailyInfo   = DailyInfo    + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(DayClPrice-DayOpPrice), 0)     + "|" + DoubleToStr(100*(MathAbs(DayClPrice-DayOpPrice)/DayOpPrice),2)       + "%]";
   WeeklyInfo  = WeeklyInfo   + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(WeekClPrice-WeekOpPrice), 0)   + "|" + DoubleToStr(100*(MathAbs(WeekClPrice-WeekOpPrice)/WeekOpPrice),2)    + "%]"; 
   MonthlyInfo = MonthlyInfo  + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(MonthClPrice-MonthOpPrice), 0) + "|" + DoubleToStr(100*(MathAbs(MonthClPrice-MonthOpPrice)/MonthOpPrice),2) + "%]";

if(ShowSignal){
   if(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0)>iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1))
     MACDColor = Blue;
   else {
     if(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0)==iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1))
       MACDColor = Gold;   
     else
       MACDColor = Red;
   }
   
   if(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0)>iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1))
     MACDInfo = MACDInfo + " M:  Up ";
   else {
     if(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0)==iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1))
       MACDInfo = MACDInfo + " M: Flat";
     else
       MACDInfo = MACDInfo + " M: Down";
   }
   
   if(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0)>iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1))
     MACDInfo = MACDInfo + " S:  Up ";
   else {
     if(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0)==iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1))
       MACDInfo = MACDInfo + " S: Flat";
     else
       MACDInfo = MACDInfo + " S: Down";
   }

   if(ShowSignalValue)
     MACDInfo   = MACDInfo + " " + DoubleToStr(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0), 5) + " " + DoubleToStr(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0), 5);
   
   if(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,0)>iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_SIGNAL,0))
     StochColor = Blue;
   else {
     if(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,0)==iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_SIGNAL,0))
       StochColor = Gold;
     else
       StochColor = Red;
   }
    
   if(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,0)>iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,1))
     StochInfo = StochInfo + " M:  Up ";
   else { 
     if(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,0)==iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,1))
       StochInfo = StochInfo + " M: Flat";
     else
       StochInfo = StochInfo + " M: Down";
   }
    
   if(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_SIGNAL,0)>iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_SIGNAL,1))
     StochInfo = StochInfo + " S:  Up ";
   else {
     if(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_SIGNAL,0)==iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_SIGNAL,1))
       StochInfo = StochInfo + " S: Flat";
     else
       StochInfo = StochInfo + " S: Down";
   }

   if(ShowSignalValue)   
     StochInfo = StochInfo + " " + DoubleToStr(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_MAIN,0),4) + " " + DoubleToStr(iStochastic(NULL,0,8,3,3,MODE_SMA,0,MODE_SIGNAL,0),4);

   if(iRSI(NULL,0,8,PRICE_CLOSE,0)>iRSI(NULL,0,8,PRICE_CLOSE,1))
     RSIColor = Blue;
   else {
     if(iRSI(NULL,0,8,PRICE_CLOSE,0)==iRSI(NULL,0,8,PRICE_CLOSE,1))
       RSIColor = Gold;
     else
       RSIColor = Red;
   }
   
   if(iRSI(NULL,0,8,PRICE_CLOSE,0)>iRSI(NULL,0,8,PRICE_CLOSE,1))
     RSIInfo  = RSIInfo + " M:  Up         "; //-- only one value shifted space for signal.
   else {
     if(iRSI(NULL,0,8,PRICE_CLOSE,0)==iRSI(NULL,0,8,PRICE_CLOSE,1))
       RSIInfo  = RSIInfo + " M: Flat        ";
     else
       RSIInfo  = RSIInfo + " M: Down        ";
   }

   if(ShowSignalValue)
     RSIInfo  = RSIInfo + " " + DoubleToStr(iRSI(NULL,0,8,PRICE_CLOSE,0),4);// + " " + DoubleToStr(iRSI(NULL,0,8,PRICE_CLOSE,1),4);

   if(iIchimoku(NULL, 0, 9, 26, 52, MODE_TENKANSEN, 0)>iIchimoku(NULL, 0, 9, 26, 52, MODE_KIJUNSEN, 0))
     IchimokuColor = Blue;
   else {
     if(iIchimoku(NULL, 0, 9, 26, 52, MODE_TENKANSEN, 0) == iIchimoku(NULL, 0, 9, 26, 52, MODE_KIJUNSEN, 0))
       IchimokuColor = Gold;
     else
       IchimokuColor = Red;
   }
   
   // T is TENKANSEN, K is KIJUNSEN, A is SENKOU SPAN A, B is SENKOU SPAN B
   if(iIchimoku(NULL, 0, 9, 26, 52, MODE_TENKANSEN, 0)>iIchimoku(NULL, 0, 9, 26, 52, MODE_TENKANSEN, 1))
     IchimokuInfo = IchimokuInfo + " T:  Up ";
   else {
     if(iIchimoku(NULL, 0, 9, 26, 52, MODE_TENKANSEN, 0)==iIchimoku(NULL, 0, 9, 26, 52, MODE_TENKANSEN, 1))
       IchimokuInfo = IchimokuInfo + " T: Flat";
     else
       IchimokuInfo = IchimokuInfo + " T: Down";
   }
   
   if(iIchimoku(NULL, 0, 9, 26, 52, MODE_KIJUNSEN, 0)>iIchimoku(NULL, 0, 9, 26, 52, MODE_KIJUNSEN, 1))
     IchimokuInfo = IchimokuInfo + " K:  Up ";
   else {
     if(iIchimoku(NULL, 0, 9, 26, 52, MODE_KIJUNSEN, 0)==iIchimoku(NULL, 0, 9, 26, 52, MODE_KIJUNSEN, 1))
       IchimokuInfo = IchimokuInfo + " K: Flat";
     else
       IchimokuInfo = IchimokuInfo + " K: Down";
   }
   
   if(iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANA, 0)>iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANA, 1))
     IchimokuInfo = IchimokuInfo + " A:  Up ";
   else {
     if(iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANA, 0)==iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANA, 1))
       IchimokuInfo = IchimokuInfo + " A: Flat";
     else
       IchimokuInfo = IchimokuInfo + " A: Down";
   }
   
   if(iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANB, 0)>iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANB, 1))
     IchimokuInfo = IchimokuInfo + " B:  Up ";
   else {
     if(iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANB, 0)==iIchimoku(NULL, 0, 9, 26, 52, MODE_SENKOUSPANB, 1))
       IchimokuInfo = IchimokuInfo + " B: Flat";
     else
       IchimokuInfo = IchimokuInfo + " B: Down";
   }

 } 
 
 //-- ShowSignal   
   if ((DayClPrice - DayOpPrice) < 0 )
     FontColorDayPercentGain = FontMinus;
    else
     FontColorDayPercentGain = FontPlus;
    
   if ((WeekClPrice - WeekOpPrice) < 0)
     FontColorWeekPercentGain = FontMinus;
    else
     FontColorWeekPercentGain = FontPlus;
    
   if ((MonthClPrice - MonthOpPrice) < 0)
     FontColorMonthPercentGain = FontMinus;
    else
     FontColorMonthPercentGain = FontPlus;

//----
   if(ObjectFind("DailyStat") == -1) {
     SetUpTextObject("DailyStat"  ,  0);
     ObjectSetText("DailyStat", DailyInfo, FontSize, Font, FontColorDayPercentGain);
     } else {
     ObjectSetText("DailyStat", DailyInfo, FontSize, Font, FontColorDayPercentGain);
     }
   if(ObjectFind("WeeklyStat") == -1) {
     SetUpTextObject("WeeklyStat" , 10);
     ObjectSetText("WeeklyStat", WeeklyInfo, FontSize, Font, FontColorWeekPercentGain);
     } else {
     ObjectSetText("WeeklyStat", WeeklyInfo, FontSize, Font, FontColorWeekPercentGain);
     }
   if(ObjectFind("MonthlyStat") == -1) {
     SetUpTextObject("MonthlyStat", 20);
     ObjectSetText("MonthlyStat", MonthlyInfo, FontSize, Font, FontColorMonthPercentGain);
     } else {
     ObjectSetText("MonthlyStat", MonthlyInfo, FontSize, Font, FontColorMonthPercentGain);
     }
if(ShowSignal) {
   if(ObjectFind("IchimokuInfo") == -1) {
     SetUpTextObject("IchimokuInfo", 60);
     ObjectSetText("IchimokuInfo", IchimokuInfo, FontSize, Font, IchimokuColor);
     } else {
     ObjectSetText("IchimokuInfo", IchimokuInfo, FontSize, Font, IchimokuColor);
     }
   if(ObjectFind("MACDInfo") == -1) {
     SetUpTextObject("MACDInfo", 50);
     ObjectSetText("MACDInfo", MACDInfo, FontSize, Font, MACDColor);
     } else {
     ObjectSetText("MACDInfo", MACDInfo, FontSize, Font, MACDColor);
     }
   if(ObjectFind("StochInfo") == -1) {
     SetUpTextObject("StochInfo", 40);
     ObjectSetText("StochInfo", StochInfo, FontSize, Font, StochColor);
     } else {
     ObjectSetText("StochInfo", StochInfo, FontSize, Font, StochColor);
     }
   if(ObjectFind("RSIInfo") == -1) {
     SetUpTextObject("RSIInfo", 30);
     ObjectSetText("RSIInfo", RSIInfo, FontSize, Font, RSIColor);
     } else {
     ObjectSetText("RSIInfo", RSIInfo, FontSize, Font, RSIColor);
     }
} //-- ShowSignal
//----

   if(DailyPercentageLevel) {
   SetUpPriceLabel("PL0.0"     , DayZeroColor, 1.000*DayOpPrice);
   SetUpPLText    ("0.0"       , DayZeroColor, 1.000*DayOpPrice);
   SetUpPriceLabel("PLUp25"    ,   DayUpColor, 1.0025*DayOpPrice);
   SetUpPLText    ("+0.25"     ,   DayUpColor, 1.0025*DayOpPrice);
   SetUpPriceLabel("PLDown25"  , DayDownColor, 0.9975*DayOpPrice);
   SetUpPLText    ("-0.25"     , DayDownColor, 0.9975*DayOpPrice);
   SetUpPriceLabel("PLUp50"    ,   DayUpColor, 1.005*DayOpPrice);
   SetUpPLText    ("+0.5"      ,   DayUpColor, 1.005*DayOpPrice);
   SetUpPriceLabel("PLDown50"  , DayDownColor, 0.995*DayOpPrice);
   SetUpPLText    ("-0.5"      , DayDownColor, 0.995*DayOpPrice);
   SetUpPriceLabel("PLUp75"    ,   DayUpColor, 1.0075*DayOpPrice);
   SetUpPLText    ("+0.75"     ,   DayUpColor, 1.0075*DayOpPrice);
   SetUpPriceLabel("PLDown75"  , DayDownColor, 0.9925*DayOpPrice);
   SetUpPLText    ("-0.75"     , DayDownColor, 0.9925*DayOpPrice);
   SetUpPriceLabel("PLUp100"   ,   DayUpColor, 1.010*DayOpPrice);
   SetUpPLText    ("+1.0"      ,   DayUpColor, 1.010*DayOpPrice);
   SetUpPriceLabel("PLDown100" , DayDownColor, 0.990*DayOpPrice);
   SetUpPLText    ("-1.0"      , DayDownColor, 0.990*DayOpPrice);
   SetUpPriceLabel("PLUp150"   ,   DayUpColor, 1.015*DayOpPrice);
   SetUpPLText    ("+1.5"      ,   DayUpColor, 1.015*DayOpPrice);
   SetUpPriceLabel("PLDown150" , DayDownColor, 0.985*DayOpPrice);
   SetUpPLText    ("-1.5"      , DayDownColor, 0.985*DayOpPrice);
   SetUpPriceLabel("PLUp200"   ,   DayUpColor, 1.020*DayOpPrice);
   SetUpPLText    ("+2.0"      ,   DayUpColor, 1.020*DayOpPrice);
   SetUpPriceLabel("PLDown200" , DayDownColor, 0.980*DayOpPrice);
   SetUpPLText    ("-2.0"      , DayDownColor, 0.980*DayOpPrice);
   if(ShowHorizontalLine) {
   SetUpHL        ("0.0HLD"    , DayZeroColor, 1.000*DayOpPrice);
   SetUpHL        ("+0.25HLD"  ,   DayUpColor, 1.0025*DayOpPrice);
   SetUpHL        ("-0.25HLD"  , DayDownColor, 0.9975*DayOpPrice);
   SetUpHL        ("+0.5HLD"   ,   DayUpColor, 1.005*DayOpPrice);
   SetUpHL        ("-0.5HLD"   , DayDownColor, 0.995*DayOpPrice);
   SetUpHL        ("+0.75HLD"  ,   DayUpColor, 1.0075*DayOpPrice);
   SetUpHL        ("-0.75HLD"  , DayDownColor, 0.9925*DayOpPrice);
   SetUpHL        ("+1.0HLD"   ,   DayUpColor, 1.010*DayOpPrice);
   SetUpHL        ("-1.0HLD"   , DayDownColor, 0.990*DayOpPrice);
   SetUpHL        ("+1.5HLD"   ,   DayUpColor, 1.015*DayOpPrice);
   SetUpHL        ("-1.5HLD"   , DayDownColor, 0.985*DayOpPrice);
   SetUpHL        ("+2.0HLD"   ,   DayUpColor, 1.020*DayOpPrice);
   SetUpHL        ("-2.0HLD"   , DayDownColor, 0.980*DayOpPrice);
   }
   }

   if(WeeklyPercentageLevel) {
   SetUpPriceLabel("PL0.0W"    , WeekZeroColor, 1.000*WeekOpPrice);
   SetUpPLText    ("0."        , WeekZeroColor, 1.000*WeekOpPrice);
   SetUpPriceLabel("PLUp100W"  ,   WeekUpColor, 1.010*WeekOpPrice);
   SetUpPLText    ("+1."       ,   WeekUpColor, 1.010*WeekOpPrice);
   SetUpPriceLabel("PLDown100W", WeekDownColor, 0.990*WeekOpPrice);
   SetUpPLText    ("-1."       , WeekDownColor, 0.990*WeekOpPrice);
   SetUpPriceLabel("PLUp200W"  ,   WeekUpColor, 1.020*WeekOpPrice);
   SetUpPLText    ("+2."       ,   WeekUpColor, 1.020*WeekOpPrice);
   SetUpPriceLabel("PLDown200W", WeekDownColor, 0.980*WeekOpPrice);
   SetUpPLText    ("-2."       , WeekDownColor, 0.980*WeekOpPrice);
   SetUpPriceLabel("PLUp300W"  ,   WeekUpColor, 1.030*WeekOpPrice);
   SetUpPLText    ("+3."       ,   WeekUpColor, 1.030*WeekOpPrice);
   SetUpPriceLabel("PLDown300W", WeekDownColor, 0.970*WeekOpPrice);
   SetUpPLText    ("-3."       , WeekDownColor, 0.970*WeekOpPrice);
   SetUpPriceLabel("PLUp400W"  ,   WeekUpColor, 1.040*WeekOpPrice);
   SetUpPLText    ("+4."       ,   WeekUpColor, 1.040*WeekOpPrice);
   SetUpPriceLabel("PLDown400W", WeekDownColor, 0.960*WeekOpPrice);
   SetUpPLText    ("-4."       , WeekDownColor, 0.960*WeekOpPrice);
   if(ShowHorizontalLine) {
   SetUpHL        ("0HLW"      , WeekZeroColor, 1.000*WeekOpPrice);
   SetUpHL        ("+1HLW"     ,   WeekUpColor, 1.010*WeekOpPrice);
   SetUpHL        ("-1HLW"     , WeekDownColor, 0.990*WeekOpPrice);
   SetUpHL        ("+2HLW"     ,   WeekUpColor, 1.020*WeekOpPrice);
   SetUpHL        ("-2HLW"     , WeekDownColor, 0.980*WeekOpPrice);
   SetUpHL        ("+3HLW"     ,   WeekUpColor, 1.030*WeekOpPrice);
   SetUpHL        ("-3HLW"     , WeekDownColor, 0.970*WeekOpPrice);
   SetUpHL        ("+4HLW"     ,   WeekUpColor, 1.040*WeekOpPrice);
   SetUpHL        ("-4HLW"     , WeekDownColor, 0.960*WeekOpPrice);
   }
   }

   if(MonthlyPercentageLevel) {
   SetUpPriceLabel("PL0.0M"    , MonthZeroColor, 1.000*MonthOpPrice);
   SetUpPLText    ("0"         , MonthZeroColor, 1.000*MonthOpPrice);
   SetUpPriceLabel("PLUp200M"  ,   MonthUpColor, 1.020*MonthOpPrice);
   SetUpPLText    ("+2"        ,   MonthUpColor, 1.020*MonthOpPrice);
   SetUpPriceLabel("PLDown200M", MonthDownColor, 0.980*MonthOpPrice);
   SetUpPLText    ("-2"        , MonthDownColor, 0.980*MonthOpPrice);
   SetUpPriceLabel("PLUp400M"  ,   MonthUpColor, 1.040*MonthOpPrice);
   SetUpPLText    ("+4"        ,   MonthUpColor, 1.040*MonthOpPrice);
   SetUpPriceLabel("PLDown400M", MonthDownColor, 0.960*MonthOpPrice);
   SetUpPLText    ("-4"        , MonthDownColor, 0.960*MonthOpPrice);
   SetUpPriceLabel("PLUp600M"  ,   MonthUpColor, 1.060*MonthOpPrice);
   SetUpPLText    ("+6"        ,   MonthUpColor, 1.060*MonthOpPrice);
   SetUpPriceLabel("PLDown600M", MonthDownColor, 0.940*MonthOpPrice);
   SetUpPLText    ("-6"        , MonthDownColor, 0.940*MonthOpPrice);
   SetUpPriceLabel("PLUp800M"  ,   MonthUpColor, 1.080*MonthOpPrice);
   SetUpPLText    ("+8"        ,   MonthUpColor, 1.080*MonthOpPrice);
   SetUpPriceLabel("PLDown800M", MonthDownColor, 0.920*MonthOpPrice);
   SetUpPLText    ("-8"        , MonthDownColor, 0.920*MonthOpPrice);
   if(ShowHorizontalLine) {
   SetUpHL        ("0HLM"      , MonthZeroColor, 1.000*MonthOpPrice);
   SetUpHL        ("+2HLM"     ,   MonthUpColor, 1.020*MonthOpPrice);
   SetUpHL        ("-2HLM"     , MonthDownColor, 0.980*MonthOpPrice);
   SetUpHL        ("+4HLM"     ,   MonthUpColor, 1.040*MonthOpPrice);
   SetUpHL        ("-4HLM"     , MonthDownColor, 0.960*MonthOpPrice);
   SetUpHL        ("+6HLM"     ,   MonthUpColor, 1.060*MonthOpPrice);
   SetUpHL        ("-6HLM"     , MonthDownColor, 0.940*MonthOpPrice);
   SetUpHL        ("+8HLM"     ,   MonthUpColor, 1.080*MonthOpPrice);
   SetUpHL        ("-8HLM"     , MonthDownColor, 0.920*MonthOpPrice);
   }
   }


   return(0);
  }
  
void SetUpTextObject(string name, int offset)
  {
   ObjectDelete(name);
   ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name, OBJPROP_BACK, back);
   ObjectSet(name, OBJPROP_CORNER, corner);
   ObjectSet(name, OBJPROP_XDISTANCE, xdis);
   ObjectSet(name, OBJPROP_YDISTANCE, ydis + offset);
   GetLastError();  
  }

void SetUpPLText(string Name, color Color, double price)
  {
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_TEXT, 0, 0, 0);
   ObjectSet(Name, OBJPROP_BACK, back);
   ObjectSet(Name, OBJPROP_TIME1, Time[0]);
   ObjectSet(Name, OBJPROP_PRICE1, price); /* double price */
   ObjectSetText(Name, Name, 7, Font, Color);
   GetLastError();  
  }

void SetUpPriceLabel(string Name, color Color, double price)
  { 
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_ARROW, 0, 0, 0 );
   ObjectSet(Name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet(Name, OBJPROP_COLOR, Color);
   ObjectSet(Name, OBJPROP_TIME1, Time[0]);
   ObjectSet(Name, OBJPROP_PRICE1, price); /* double price */
   GetLastError();
  }
  
 void SetUpHL(string Name, color Color, double price)
  {
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_HLINE, 0, 0, 0);
   ObjectSet(Name, OBJPROP_COLOR, Color);
   ObjectSet(Name, OBJPROP_STYLE, STYLE_DOT);
   ObjectSet(Name, OBJPROP_WIDTH, 1);
   ObjectSet(Name, OBJPROP_PRICE1, price);
   GetLastError();
  }
//+------------------------------------------------------------------+  